"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
/* @internal */
class ZipAsyncIterable {
    constructor(xs, ys) {
        this.xs = xs;
        this.ys = ys;
    }
    [Symbol.asyncIterator]() {
        return new ZipAsyncIterator(this.xs[Symbol.asyncIterator](), utils_1.isIterable(this.ys)
            ? this.ys[Symbol.iterator]()
            : this.ys[Symbol.asyncIterator]());
    }
}
exports.ZipAsyncIterable = ZipAsyncIterable;
/* @internal */
class ZipWithAsyncIterable {
    constructor(f, xs, ys) {
        this.f = f;
        this.xs = xs;
        this.ys = ys;
    }
    [Symbol.asyncIterator]() {
        return new ZipWithAsyncIterator(this.f, this.xs[Symbol.asyncIterator](), utils_1.isIterable(this.ys)
            ? this.ys[Symbol.iterator]()
            : this.ys[Symbol.asyncIterator]());
    }
}
exports.ZipWithAsyncIterable = ZipWithAsyncIterable;
class ZipAsyncIterator {
    constructor(xs, ys) {
        this.xs = xs;
        this.ys = ys;
    }
    next(value) {
        return __awaiter(this, void 0, void 0, function* () {
            const r1 = yield this.xs.next(value);
            const r2 = yield this.ys.next(value);
            if (!r1.done && !r2.done) {
                return {
                    done: false,
                    value: [r1.value, r2.value],
                };
            }
            else {
                return { done: true };
            }
        });
    }
}
class ZipWithAsyncIterator {
    constructor(f, xs, ys) {
        this.f = f;
        this.xs = xs;
        this.ys = ys;
    }
    next(value) {
        return __awaiter(this, void 0, void 0, function* () {
            const r1 = yield this.xs.next(value);
            const r2 = yield this.ys.next(value);
            if (!r1.done && !r2.done) {
                return {
                    done: false,
                    value: this.f(r1.value, r2.value),
                };
            }
            else {
                return { done: true };
            }
        });
    }
}
