"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* @internal */
class DropIterable {
    constructor(n, xs) {
        this.n = n;
        this.xs = xs;
    }
    [Symbol.iterator]() {
        return drop(this.n, this.xs);
    }
}
exports.DropIterable = DropIterable;
/* @internal */
class DropWhileIterable {
    constructor(p, xs) {
        this.p = p;
        this.xs = xs;
    }
    [Symbol.iterator]() {
        return dropWhile(this.p, this.xs);
    }
}
exports.DropWhileIterable = DropWhileIterable;
function* drop(n, xs) {
    for (const x of xs) {
        if (n > 0) {
            --n;
        }
        else {
            yield x;
        }
    }
}
function* dropWhile(p, xs) {
    let dropping = true;
    for (const x of xs) {
        if (dropping) {
            if (p(x)) {
                continue;
            }
            else {
                dropping = false;
                yield x;
            }
        }
        else {
            yield x;
        }
    }
}
