"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* @internal */
class RangeIterable {
    constructor(start, stop, step) {
        this.start = start;
        this.stop = stop;
        this.step = step;
    }
    [Symbol.iterator]() {
        return range(this.start, this.stop, this.step);
    }
}
exports.RangeIterable = RangeIterable;
/* @internal */
class EnumFromIterable {
    constructor(start, step) {
        this.start = start;
        this.step = step;
    }
    [Symbol.iterator]() {
        return enumFrom(this.start, this.step);
    }
}
exports.EnumFromIterable = EnumFromIterable;
/* @internal */
function* enumFrom(start, step) {
    for (let i = start;; i += step) {
        yield i;
    }
}
exports.enumFrom = enumFrom;
function* range(start, stop, step) {
    for (let i = start; i <= stop; i += step) {
        yield i;
    }
}
