"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* @internal */
class ZipIterable {
    constructor(iter1, iter2) {
        this.iter1 = iter1;
        this.iter2 = iter2;
    }
    [Symbol.iterator]() {
        return new ZipIterator(this.iter1[Symbol.iterator](), this.iter2[Symbol.iterator]());
    }
}
exports.ZipIterable = ZipIterable;
/* @internal */
class ZipWithIterable {
    constructor(f, iter1, iter2) {
        this.f = f;
        this.iter1 = iter1;
        this.iter2 = iter2;
    }
    [Symbol.iterator]() {
        return new ZipWithIterator(this.f, this.iter1[Symbol.iterator](), this.iter2[Symbol.iterator]());
    }
}
exports.ZipWithIterable = ZipWithIterable;
class ZipIterator {
    constructor(it1, it2) {
        this.it1 = it1;
        this.it2 = it2;
    }
    next(value) {
        const r1 = this.it1.next(value);
        const r2 = this.it2.next(value);
        if (!r1.done && !r2.done) {
            return {
                done: false,
                value: [r1.value, r2.value],
            };
        }
        else {
            return { done: true };
        }
    }
}
class ZipWithIterator {
    constructor(f, it1, it2) {
        this.f = f;
        this.it1 = it1;
        this.it2 = it2;
    }
    next(value) {
        const r1 = this.it1.next(value);
        const r2 = this.it2.next(value);
        if (!r1.done && !r2.done) {
            return {
                done: false,
                value: this.f(r1.value, r2.value),
            };
        }
        else {
            return { done: true };
        }
    }
}
